
EnemyHeathBarAddon = LibStub("AceAddon-3.0"):NewAddon("Enemy Health Bar", "AceEvent-3.0", "AceConsole-3.0")

defaults = {
	profile = {
		Scale = 1.0,
		InCombat = true,
		InDeath = true,
		InOther = false,
		Locked = false,
		Execution = false,
		AsPercent = true,
		WhichTarget = 1
	}
}


function EnemyHeathBarAddon:OnInitialize()

	EnemyHealthFrames = {};
	highhealth = true;

	ehbTarget = {"target", "focus", "focustarget"};

	self.db = LibStub("AceDB-3.0"):New("EnemyHealthBarDB", defaults, true)
	myOptions = {
		type = "group",
		args = {
			target = {
				name = "Show Who's Health",
				type = "select",
				values = {"My Target                                                                                                  ",
					"My Focus                                                                                                   ",
					"My Focus' Target                                                                                           "},
				set = function(info,val) self.db.profile.WhichTarget = val; updateTargetHealthBar(); end,
				get = function(info) return self.db.profile.WhichTarget end,
				order = 0,
				width = "double"
			},
			scale = {
				name = "Scale",
				type = "range",
				min = 0.5,
				max = 3.0,
				step = 0.01,
				set = function(info,val) self.db.profile.Scale = val; EnemyHealthFrame:SetScale(self.db.profile.Scale); end,
				get = function(info) return self.db.profile.Scale end,
				order = 1,
				width = "double"
			},
			combat = {
				name = "Show In Combat",
				type = "toggle",
				set = function(info,val) self.db.profile.InCombat = val; ehbtoggle(); end,
				get = function(info) return self.db.profile.InCombat end,
				order = 2,
				width = "double"
			},
			dead = {
				name = "Show While Dead",
				type = "toggle",
				set = function(info,val) self.db.profile.InDeath = val; ehbtoggle(); end,
				get = function(info) return self.db.profile.InDeath end,
				order = 3,
				width = "double"
			},
			other = {
				name = "Show While Not In Combat",
				type = "toggle",
				set = function(info,val) self.db.profile.InOther = val; ehbtoggle(); end,
				get = function(info) return self.db.profile.InOther end,
				order = 4,
				width = "double"
			},
			viewstyle = {
				name = "Show Health as %",
				type = "toggle",
				set = function(info,val) self.db.profile.AsPercent = val; updateTargetHealthBar(); end,
				get = function(info) return self.db.profile.AsPercent end,
				order = 5,
				width = "double"
			},
			lowhealth = {
				name = "Low Health Warning",
				desc = "Sounds to warn when health drops below 35%",
				type = "toggle",
				set = function(info,val) self.db.profile.Execution = val end,
				get = function(info) return self.db.profile.Execution end,
				order = 6,
				width = "double"
			},
			locked = {
				name = "Lock",
				type = "toggle",
				set = function(info,val) self.db.profile.Locked = val; ehbtoggle(); end,
				get = function(info) return self.db.profile.Locked end,
				order = 7,
				width = "double"
			}
		}
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Enemy Health Bar", myOptions)
	ehboptions = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Enemy Health Bar")

	function GetChildrenTree(Frame) --- Walk the frame hierarchy recursively adding children.
		if Frame:GetChildren() then
			for _,child in pairs({Frame:GetChildren()}) do
				if child:IsMouseEnabled() then
					tinsert(EnemyHealthFrames,child);
				end
				GetChildrenTree(child);
			end 
		end
	end
	GetChildrenTree(EnemyHealthFrame);
	
	EnemyHealthFrame:SetScale(self.db.profile.Scale)

	if UnitIsGhost("player") then 
		EnemyHealthFrame:Hide();
	elseif (UnitIsDead("player") and (self.db.profile.InDeath)) then
		EnemyHealthFrame:Show();
	elseif UnitIsDead("player") then
		EnemyHealthFrame:Hide();
	elseif (UnitAffectingCombat("player") and self.db.profile.InCombat) then
		EnemyHealthFrame:Show();
	elseif (self.db.profile.InOther and not(UnitAffectingCombat("player"))) then
		EnemyHealthFrame:Show();
	else
		EnemyHealthFrame:Hide();
	end
	-- check lock status and enable/disable mouse.
	if EnemyHealthFrame:IsVisible() then
		if self.db.profile.Locked then
			EnemyHealthFrame:EnableMouse(false);
			for _,childframe in pairs (EnemyHealthFrames) do
				childframe:EnableMouse(false);
			end
		else
			EnemyHealthFrame:EnableMouse(true);
			for _,childframe in pairs (EnemyHealthFrames) do
				childframe:EnableMouse(true);
			end		
		end
		-- if Target Health is disabled or target doesnt exists or target is player then hide the frame
		if (UnitExists(ehbTarget[self.db.profile.WhichTarget]) and not UnitIsUnit(ehbTarget[self.db.profile.WhichTarget], "player")) then
			EnemyHealthBorderTargetHealth:Show();
		else
			EnemyHealthBorderTargetHealth:Hide();
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cffcc33ffEnemy Health Bar 5.1.0 Loaded.  Type /ehb for Options.|r");
end


function EnemyHeathBarAddon:OnEnable()

function updateTargetHealthBar()
	local value, max = UnitHealth(ehbTarget[self.db.profile.WhichTarget]), UnitHealthMax(ehbTarget[self.db.profile.WhichTarget]);
	local vtext, tvalue, tmax;
	local health;
	local Frame = _G["EnemyHealthTargetHealthBar"];
	if (UnitExists(ehbTarget[self.db.profile.WhichTarget]) and not UnitIsUnit(ehbTarget[self.db.profile.WhichTarget], "player")) then
		if UnitIsGhost("player") then 
			EnemyHealthBorderTargetHealth:Hide();
		elseif (UnitIsDead("player") and (self.db.profile.InDeath)) then
			EnemyHealthBorderTargetHealth:Show();
		elseif UnitIsDead("player") then
			EnemyHealthBorderTargetHealth:Hide();
		elseif (UnitAffectingCombat("player") and self.db.profile.InCombat) then
			EnemyHealthBorderTargetHealth:Show();
		elseif (self.db.profile.InOther and not(UnitAffectingCombat("player"))) then
			EnemyHealthBorderTargetHealth:Show();
		else
			EnemyHealthBorderTargetHealth:Hide();
		end
	else
		EnemyHealthBorderTargetHealth:Hide();
	end

	health = math.ceil( value / max * 100 );
	if UnitReaction(ehbTarget[self.db.profile.WhichTarget], "player") == 4 then
		EnemyHealthTargetHealthBar:SetStatusBarColor(1, 1, 0);
		if health < 35 and (highhealth) and (self.db.profile.Execution) then
			if (EnemyHealthFrame:IsVisible()) and (health > 0) then
				PlaySoundFile("sound\\doodad\\BellTollAlliance.ogg");
			end
			highhealth = false;
		end
		if health >= 35 then
			highhealth = true;
		end
	elseif (UnitIsFriend("player", ehbTarget[self.db.profile.WhichTarget])) then
		EnemyHealthTargetHealthBar:SetStatusBarColor(0, 1, 0);
		if health < 35 and (highhealth) and (self.db.profile.Execution) then
			if (EnemyHealthFrame:IsVisible()) and (health > 0) then
				PlaySoundFile("sound\\doodad\\BellTollAlliance.ogg");
			end
			highhealth = false;
		end
		if health >= 35 then
			highhealth = true;
		end
	else
		if health < 35 and (highhealth) and (self.db.profile.Execution) then
			if (EnemyHealthFrame:IsVisible()) and (health > 0) then
				PlaySoundFile("sound\\doodad\\BellTollAlliance.ogg");
			end
			EnemyHealthTargetHealthBar:SetStatusBarColor(0.35, 0, 0.35);
			highhealth = false;
		end
		if health >= 35 then
			EnemyHealthTargetHealthBar:SetStatusBarColor(1, 0, 0);
			highhealth = true;
		end
	end		

	if (self.db.profile.AsPercent) then
		vtext = health .. "%";
	else
		if value >= 100000 then
			tvalue = math.floor(value / 1000) .. "K ";
		else
			tvalue = value .. " ";
		end
		if max >= 100000 then
			tmax = " " .. math.floor(max / 1000) .. "K";
		else
			tmax = " " .. max;
		end
		vtext = tvalue .. "/" .. tmax;
	end

	Frame:SetMinMaxValues(0, max);
	Frame:SetValue(value);
	EnemyHealthTargetHealthText:SetText(vtext);
end

function ehbtoggle()
	if UnitIsGhost("player") then 
		EnemyHealthFrame:Hide();
	elseif (UnitIsDead("player") and (self.db.profile.InDeath)) then
		EnemyHealthFrame:Show();
	elseif UnitIsDead("player") then
		EnemyHealthFrame:Hide();
	elseif (UnitAffectingCombat("player") and self.db.profile.InCombat) then
		EnemyHealthFrame:Show();
	elseif (self.db.profile.InOther and not(UnitAffectingCombat("player"))) then
		EnemyHealthFrame:Show();
	else
		EnemyHealthFrame:Hide();
	end
	-- check lock status and enable/disable mouse.
	if EnemyHealthFrame:IsVisible() then
		if self.db.profile.Locked then
			EnemyHealthFrame:EnableMouse(false);
			for _,childframe in pairs (EnemyHealthFrames) do
				childframe:EnableMouse(false);
			end
		else
			EnemyHealthFrame:EnableMouse(true);
			for _,childframe in pairs (EnemyHealthFrames) do
				childframe:EnableMouse(true);
			end		
		end
		-- if Target Health is disabled or target doesnt exists or target is player then hide the frame
		if (UnitExists(ehbTarget[self.db.profile.WhichTarget]) and not UnitIsUnit(ehbTarget[self.db.profile.WhichTarget], "player")) then
			EnemyHealthBorderTargetHealth:Show();
		else
			EnemyHealthBorderTargetHealth:Hide();
		end
	end
end


function ehbeventHandler1(...)
	EnemyHealthFrame:SetScale(self.db.profile.Scale);
end

function ehbeventHandler2(...)
	local arg1, arg2 = ...;
	if arg2 == ehbTarget[self.db.profile.WhichTarget] then
		updateTargetHealthBar();
	end
end

function ehbeventHandler3(...)
	updateTargetHealthBar();
end

function ehbeventHandler4(...)
	ehbtoggle();
end

function ehbeventHandler5(...)
	local arg1, arg2 = ...;
	if arg2 == "focus" then
		updateTargetHealthBar();
	end
end

function ehbcommandHandler(str)
	InterfaceOptionsFrame_OpenToCategory(ehboptions)
end

	EnemyHeathBarAddon:RegisterEvent("VARIABLES_LOADED", ehbeventHandler1);
	EnemyHeathBarAddon:RegisterEvent("UNIT_HEALTH", ehbeventHandler2);
	EnemyHeathBarAddon:RegisterEvent("PLAYER_TARGET_CHANGED", ehbeventHandler3);
	EnemyHeathBarAddon:RegisterEvent("PLAYER_FOCUS_CHANGED", ehbeventHandler3);
	EnemyHeathBarAddon:RegisterEvent("PLAYER_REGEN_DISABLED", ehbeventHandler4);
	EnemyHeathBarAddon:RegisterEvent("PLAYER_REGEN_ENABLED", ehbeventHandler4);
	EnemyHeathBarAddon:RegisterEvent("PLAYER_DEAD", ehbeventHandler4);
	EnemyHeathBarAddon:RegisterEvent("UNIT_TARGET", ehbeventHandler5);

	EnemyHeathBarAddon:RegisterChatCommand("ehb", ehbcommandHandler);
end

